(function () {
    "use strict";

    angular.module('pos').controller('clienteAtacadoController', controller);
    controller.$inject = ['$scope', '$window', '$timeout', 'clienteService'];

    function controller($scope, $window, $timeout, clienteService) {
        $scope.$parent.initializeLayout('Clientes Atacado');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                chaves: '',
                codigocliente: '',
                cpf: '',
                fone: '',
                genero: '',
                ultimaCompra: {
                    de: '',
                    ate: ''
                },
                mesAniversario: '',
                idade: {
                    de: '',
                    ate: ''
                },
                skip: 0,
                take: 20
            }
        };

        function getDateWithoutTime(date) {
            var dateObj = new Date(date);
            var dateWithoutTime = dateObj.toLocaleDateString();

            return dateWithoutTime;
        }

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };
        $scope.historyBack = function () {
            $window.history.back();
        };

        $scope.getAll = function () {
            $scope.state.filtro.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            clienteService.getAll($scope.state.filtro)
                .then(
                    function (response) {
                        if (response.Status < 0)
                            $scope.$parent.toastr.error(response.Message, "Serviço");
                        else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data.length == 0);
                    },
                    function (err) { $scope.$parent.toastr.error(err); }
                );
        };
        $scope.count = function () {
            clienteService
                .count($scope.state.filtro)
                .then(
                    function (response) {
                        if (response.Status < 0)
                            $scope.$parent.toastr.error(response.Message, 'Serviço');
                        else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (err) { $scope.$parent.toastr.error(err); }
                );
        };
        $scope.Processado = true;
        $scope.getMore = function () {
            if ($scope.Processado == false)
                return;
            $scope.Processado = false;
            $scope.state.filtro.skip += $scope.state.filtro.take;
            clienteService
                .getAll($scope.state.filtro)
                .then(
                    function (response) {
                        if (response.Status < 0)
                            $scope.$parent.toastr.error(response.Message, 'Serviço');
                        else {

                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                        $scope.Processado = true;
                    },
                    function (err) { $scope.$parent.toastr.error(err); $scope.Processado = true; }

                );
        };
        $scope.refresh = function () {

            if ($scope.state.filtro.ultimaCompra.de) {
                var emissaoDe = $scope.state.filtro.ultimaCompra.de;
                var emissaoDeNoTime = getDateWithoutTime(emissaoDe);
                $scope.state.filtro.ultimaCompra.de = emissaoDeNoTime;
            }
            if ($scope.state.filtro.ultimaCompra.ate) {
                var emissaoAte = $scope.state.filtro.ultimaCompra.ate;
                var emissaoAteNoTime = getDateWithoutTime(emissaoAte);
                $scope.state.filtro.ultimaCompra.ate = emissaoAteNoTime;
            }

            $scope.getAll();
            $scope.count();
        }
        $scope.clearFilter = function () {
            $scope.state.filtro.chaves = '';
            $scope.state.filtro.codigocliente = '';
            $scope.state.filtro.cpf = '';
            $scope.state.filtro.fone = '';
            $scope.state.filtro.genero = '';
            $scope.state.filtro.ultimaCompra.de = '';
            $scope.state.filtro.ultimaCompra.ate = '';
            $scope.state.filtro.mesAniversario = '';
            $scope.state.filtro.idade.de = '';
            $scope.state.filtro.idade.ate = '';

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
            if ($scope.state.filtro.ativo)
                $timeout(function () { $('[ng-model$="items.filtro.chaves"]').focus() });
        };

        $scope.confirmFidelidade = function () {
            if (!$scope.items.data.Fidelidade) {
                $scope.items.data.Fidelidade = true;
                $confirm({ text: "Ao desmarcar esta opção o cliente NÃO participará do programa de fidelidade, Deseja Confirmar?", title: "Desabilitar Fidelidade", ok: "Sim", cancel: "Não" })
                .then(function () {
                    $scope.items.data.Fidelidade = false;
                });
            } else if ($scope.items.data.Fidelidade) {
                $scope.items.data.Fidelidade = false;
                $confirm({ text: "Ao marcar esta opção o cliente passará a fazer parte do programa de fidelidade, Deseja Confirmar?", title: "Habilitar Fidelidade", ok: "Sim", cancel: "Não" })
                .then(function () {
                    $scope.items.data.Fidelidade = true;
                });
            }
        }

        $scope.initialize();
    }

})();